#include "aide-osd.h"
#include "aide.h"
static const cFont *font = cFont::GetFont(fontOsd); 

cAideOsd::cAideOsd (void)
{
	osd=NULL;
	asprintf(&Header.Name,"%s","");
	asprintf(&Header.Version,"%s","");
	asprintf(&Header.Autor,"%s","");
	BodyCurrent=0;
	BodyNbrPage=0;
}

cAideOsd::~cAideOsd(void)
{
	PlugAide.Osd=false;
	delete osd;
}

void cAideOsd::DrawHeader()
{
	char *buff;
	asprintf(&buff,"Plugin : %s Version : %s By : %s",Header.Name,Header.Version,Header.Autor);
	osd->DrawRectangle(0,0,623,30,0xBFCACACA);
	osd->DrawText(0,0,buff,clrBlack,0xBFCACACA,font);
	osd->Flush();
}

void cAideOsd::DrawFooter()
{
	char *buff;
	asprintf(&buff,"Plugin Aide v%s    Page %i/%i",PlugAide.Version(),BodyCurrent+1,BodyNbrPage);
	osd->DrawRectangle(0,255,623,285,0xBFCACACA);
	osd->DrawText(0,255,buff,clrBlack,0xBFCACACA,font);
	osd->Flush();
}
void cAideOsd::DrawBody(int page)
{
	int i=0;
	int from=page*(215/font->Height(Body[0]));
	osd->DrawRectangle(0,35,623,250,0xBFCACACA);
	while (Body[from] && (i*font->Height(Body[0])<215) )
	{
		osd->DrawText(0,35+(i*font->Height(Body[from])),Body[from],clrBlack,0xBFCACACA,font);
		i++;
		from++;
	}
	osd->Flush();
}

void cAideOsd::Show(void)
{
	osd=cOsdProvider::NewOsd(50,50);
	tArea Areas[]={ {0,0,623,30,2},
       			{0,35,623,250,4},
			{0,255,623,285,2}
		      };
	osd->SetAreas(Areas,sizeof(Areas)/sizeof(tArea));
	osd->Flush();
	Load();
	DrawHeader();
	DrawBody(0);
	DrawFooter();
}

void cAideOsd::DrawImg(char *name,int x,int y)
{
	cBitmap *bmp = new cBitmap(1,1,1);
	if (bmp->LoadXpm(name))
	{
		osd->DrawBitmap(x,y,*bmp);
	}
}


void cAideOsd::Load()
{
	char *Chemin;
	asprintf (&Chemin,"%s/aide/%s/%s.aide",cPlugin::ConfigDirectory(),PlugAide.OsdAideName,PlugAide.OsdAideName);
	FILE *f;
	f=fopen(Chemin,"r");
	if (f)
	{
		int i=0;
	char buff[256];
	while (fgets(buff,sizeof(buff),f))
		{
			if (!strcmp(buff,":HEADER\n")) 
			{
				char *fgetresult=buff;
				while(fgetresult && strcmp(buff,":BODY\n"))
				{
					char *tmp;
					strtok(buff,"=");
					if (!strcmp(buff,"NAME")) 
					{
						tmp=strtok(NULL,"=");
						asprintf(&Header.Name,"%s",tmp);
					}
					else if (!strcmp(buff,"VERSION"))
					{
						tmp=strtok(NULL,"=");
						asprintf(&Header.Version,"%s",tmp);
					}
					else if (!strcmp(buff,"AUTOR"))
					{
						tmp=strtok(NULL,"=");
						asprintf(&Header.Autor,"%s",tmp);
					}
					fgetresult=fgets(buff,sizeof(buff),f);
				}
				fgets(buff,sizeof(buff),f);
			}
			char *buff3=NULL;
			char *buff2=NULL;
			asprintf(&buff2,"%s","");
			asprintf(&buff3,"%s",buff);

			strtok(buff3," ");
			while (buff3)
			{
				if ((font->Width(buff2)+font->Width(buff3)) < osd->Width())
				{
					asprintf(&buff2,"%s %s",buff2,buff3);
				}
				else
				{
					asprintf(&Body[i],"%s",buff2);
					i++;
					asprintf(&buff2,"%s",buff3);
				}
				buff3=strtok(NULL," ");
			}
			asprintf(&Body[i],"%s",buff2);
			i++;
			asprintf(&buff2,"%s","");
		}
	Body[i]=NULL;
	fclose(f);
	BodyNbrPage=(i*font->Height(Body[0]))/200+1;
	}	
}

eOSState cAideOsd::ProcessKey(eKeys Key)
{
	eOSState state = cOsdObject::ProcessKey(Key);
	switch (Key)
	{
		case kUp: 
			  if (BodyCurrent < (BodyNbrPage-1))
			  BodyCurrent=BodyCurrent+1;
			  DrawBody(BodyCurrent);
			  DrawFooter();
			  break;
		case kDown:
			  if (BodyCurrent > 0)
			  BodyCurrent=BodyCurrent-1;
			  DrawBody(BodyCurrent);
			  DrawFooter();
			  break;
		case kBack : 
		case kBlue:
			  return osEnd;
			     break;
		default : break;
	}
	return state;
}
