#include "aide.h"
#include "menuaide.h"
#include "affichageaide.h"
#include "aideplayer.h"
#include <vdr/player.h>
#include <dirent.h>


cMenuAide::cMenuAide(void) : cOsdMenu ("VDR Aide",20)
{
	Draw();
}

void cMenuAide::Draw(void)
{
	cOsdItem *item = new cOsdItem("Liste des aides disponibles:");
	item->SetSelectable(false);
	Add(item);
	FindAide();
	SetCurrent(Get(1));
}

void cMenuAide::FindAide(void)
{
char *dir;
char *dir2;
char *AideFile;
char *AideLine;
asprintf(&dir,"%s/aide/",cPlugin::ConfigDirectory());
DIR *d = opendir(dir);
if(d)
{
	struct dirent *e;
	struct dirent *e2;
	SetHelp("StillImage",NULL,NULL,"OsdTest");
	while ((e = readdir(d)) != NULL)
	{
		if (strcmp(e->d_name,".") && strcmp(e->d_name,".."))
		{
			asprintf(&dir2,"%s%s",dir,e->d_name);
			asprintf(&AideFile,"%s.%s",e->d_name,"aide");
			DIR *d2 = opendir(dir2);
			if (d2)
			{
				while (( e2 = readdir(d2)) != NULL)
				{
					if (!strcmp(e2->d_name,AideFile))
					{
						asprintf(&AideLine,"    %s",e->d_name);
						Add(new cOsdItem(AideLine,osUser1));

					}
				}
			}
		}
	}
}
}

cMenuAide::~cMenuAide(void)
{
}

eOSState cMenuAide::ProcessKey(eKeys Key)
{
	eOSState state = cOsdMenu::ProcessKey(Key);
	switch (state)
	{
		case osUser1:
			return (AddSubMenu(new cAffichageAide(Get(Current())->Text())));
			break;
		default : break;
	}
	if (state == osUnknown && !HasSubMenu())
	{
		switch(Key)
		{
			case kRed:
				CloseSubMenu();
				cControl::Launch(new cAidePlayerControl(Trim(Get(Current())->Text())));
				return osEnd;
				break;
			case kBlue :
				PlugAide.Osd=true;
				asprintf(&PlugAide.OsdAideName,"%s",Trim(Get(Current())->Text()));
				CloseSubMenu();
				return osPlugin;
				break;
			default : break;
		}
	}
	return state;
}


char *cMenuAide::Trim(const char *totrim)
{
	char *result="";
	for (int i=0;i<(int) strlen(totrim);i++)
	{
		if (totrim[i]!=' ')
		{
			asprintf(&result,"%s%c",result,totrim[i]);
		}
	}
	return result;
}
